/*
 * Copyright 2011 Steven Gribble
 *
 *  This file is part of the UW CSE 333 course project sequence
 *  (333proj).
 *
 *  333proj is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  333proj is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with 333proj.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <arpa/inet.h>  // for ntohl(), etc.
#include <stdint.h>     // for uint32_t, etc.

#include "./fileindexutil.h"  // for ntohll()
#include "./DocIDTableReader.h"

extern "C" {
  #include "libhw1/Assert333.h"
}

namespace hw3 {

// The constructor for DocIDTableReader calls the constructor
// of HashTableReader(), its superclass. The superclass takes
// care of taking ownership of f and using it to extract and
// cache the number of buckets within the table.
DocIDTableReader::DocIDTableReader(FILE *f, uint32_t offset)
  : HashTableReader(f, offset) { }

bool DocIDTableReader::LookupDocID(const uint64_t &docid,
                                   std::list<uint32_t> *ret_list) {
  // Use the superclass's "LookupElementPositions" function to
  // walk through the docIDtable and get back a list of offsets
  // to elements in the bucket for this docID.
  std::list<uint32_t> elements = LookupElementPositions(docid);

  // If the list of elements is empty, we're done.
  if (elements.size() == 0)
    return false;

  // Iterate through the elements, looking for our docID.
  std::list<uint32_t>::iterator it;
  for (it = elements.begin(); it != elements.end(); it++) {
    uint32_t next_offset = *it;

    // Slurp the next docid out of the element.
    uint64_t element_docid;
    // MISSING:


    // Is it a match?
    if (element_docid == docid) {
      // Yes!  Extract the number of positions in the list.
      uint32_t num_pos;
      // MISSING:


      // Extract the positions themselves, appending to
      // std::list<uint32_t>.  Be sure to push in the right
      // order, adding to the end of the list as you extract
      // successive positions.

      // MISSING:



      // Return the positions list through the output parameter,
      // and return true.

      // MISSING:


      return true;
    }
  }

  // We failed to find a matching docID, so return false.
  return false;
}

list<pair<uint64_t, uint32_t> > DocIDTableReader::GetDocIDList() {
  // This will be our returned list of docIDs within this table.
  list<pair<uint64_t, uint32_t> > docidlist;

  // Go through *all* of the buckets of this hashtable, extracting
  // out the docids in each element and the number of word positions
  // for the each docid.
  for (uint32_t i = 0; i < num_buckets_; i++) {
    // Seek to the next bucket_rec.  The "offset_" member
    // variable stores the offset of this docid table within
    // the index file.
    // MISSING:


    // Read in the chain length and bucket position fields from
    // the bucket_rec.
    uint32_t chainlen, bucketposition;
    // MISSING:


    // Sweep through the next bucket, iterating through each
    // chain element in the bucket.
    for (uint32_t j = 0; j < chainlen; j++) {
      // Seek to chain element's position field in the bucket header.
      Assert333(fseek(file_, bucketposition + j*4, SEEK_SET) == 0);

      // Read the next element position from the bucket header.
      uint32_t elementposition;
      // MISSING:

      // Seek to the element itself.
      // MISSING:

      // Read in the docid from the element.
      uint64_t docid;
      // MISSING:

      // Read in the number of positions from the element.
      uint32_t numposn;
      // MISSING:


      // Append it to our result list.
      docidlist.push_back(pair<uint64_t, uint32_t>(docid, numposn));
    }
  }

  // Done!  Return the result list.
  return docidlist;
}

}  // namespace hw3
